# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ublox_msgs/MonVER.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ublox_msgs.msg

class MonVER(genpy.Message):
  _md5sum = "83c8a03d7744e76cc085d953e1a5a293"
  _type = "ublox_msgs/MonVER"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# MON-VER (0x0A 0x04)
#
# Receiver/Software Version
# Returned when the version is polled.

uint8 CLASS_ID = 10
uint8 MESSAGE_ID = 4

char[30] swVersion    # Zero-terminated software version string.
char[10] hwVersion    # Zero-terminated hardware version string.

# Start of repeated block (N times)
MonVER_Extension[] extension
# End of repeated block

================================================================================
MSG: ublox_msgs/MonVER_Extension
# see MonVER message
#

char[30] field"""
  # Pseudo-constants
  CLASS_ID = 10
  MESSAGE_ID = 4

  __slots__ = ['swVersion','hwVersion','extension']
  _slot_types = ['char[30]','char[10]','ublox_msgs/MonVER_Extension[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       swVersion,hwVersion,extension

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MonVER, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.swVersion is None:
        self.swVersion = b'\0'*30
      if self.hwVersion is None:
        self.hwVersion = b'\0'*10
      if self.extension is None:
        self.extension = []
    else:
      self.swVersion = b'\0'*30
      self.hwVersion = b'\0'*10
      self.extension = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.swVersion
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_30B().pack(*_x))
      else:
        buff.write(_get_struct_30s().pack(_x))
      _x = self.hwVersion
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_10B().pack(*_x))
      else:
        buff.write(_get_struct_10s().pack(_x))
      length = len(self.extension)
      buff.write(_struct_I.pack(length))
      for val1 in self.extension:
        _x = val1.field
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(_get_struct_30B().pack(*_x))
        else:
          buff.write(_get_struct_30s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.extension is None:
        self.extension = None
      end = 0
      start = end
      end += 30
      self.swVersion = str[start:end]
      start = end
      end += 10
      self.hwVersion = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.extension = []
      for i in range(0, length):
        val1 = ublox_msgs.msg.MonVER_Extension()
        start = end
        end += 30
        val1.field = str[start:end]
        self.extension.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.swVersion
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_30B().pack(*_x))
      else:
        buff.write(_get_struct_30s().pack(_x))
      _x = self.hwVersion
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_10B().pack(*_x))
      else:
        buff.write(_get_struct_10s().pack(_x))
      length = len(self.extension)
      buff.write(_struct_I.pack(length))
      for val1 in self.extension:
        _x = val1.field
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(_get_struct_30B().pack(*_x))
        else:
          buff.write(_get_struct_30s().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.extension is None:
        self.extension = None
      end = 0
      start = end
      end += 30
      self.swVersion = str[start:end]
      start = end
      end += 10
      self.hwVersion = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.extension = []
      for i in range(0, length):
        val1 = ublox_msgs.msg.MonVER_Extension()
        start = end
        end += 30
        val1.field = str[start:end]
        self.extension.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10B = None
def _get_struct_10B():
    global _struct_10B
    if _struct_10B is None:
        _struct_10B = struct.Struct("<10B")
    return _struct_10B
_struct_10s = None
def _get_struct_10s():
    global _struct_10s
    if _struct_10s is None:
        _struct_10s = struct.Struct("<10s")
    return _struct_10s
_struct_30B = None
def _get_struct_30B():
    global _struct_30B
    if _struct_30B is None:
        _struct_30B = struct.Struct("<30B")
    return _struct_30B
_struct_30s = None
def _get_struct_30s():
    global _struct_30s
    if _struct_30s is None:
        _struct_30s = struct.Struct("<30s")
    return _struct_30s
